<?php
/**
Plugin Name: 彩色标签云
Plugin URI: http://cnzhx.net/blog/colorful-tags-cloud/
Description: Give tags cloud wonderful colors.
Version: 1.0
Author: <a href="http://cnzhx.net/">Haoxian Zeng</a>
*/

/**
 * Give tags cloud wonderful colors.
 *
 * Tested with WP 3.5.1
 *
 * Hooked to wp_tag_cloud filter
 * See http://codex.wordpress.org/Function_Reference/wp_tag_cloud
 *
 * @param $text, string of default tags html code
 * @return $text, modified string of tags html code
 * @author Haoxian Zeng http://cnzhx.net/
 * 
 * ref:
 * Colorful tags cloud
 * Maybe original: http://wanwp.com/tips-tricks/howto-make-a-colorful-tag-cloud/
 * Could be improved according to: http://betterwp.net/22-customize-your-wordpress-tag-cloud/
 */

function colorCloud($text) { 
    $text = preg_replace_callback('|<a (.+?)>|i', 'colorCloudCallback', $text); 
    return $text; 
}

function colorCloudCallback($matches) { 
    $text = $matches[1]; 
    // set color range (0,16777215), here is #000000 to #ffffff
    // and random pick up one to use on current tag of all the tags
    // $color = dechex(rand(0,12345678));
    // change this line to avoid too bright color base on the background(#ffffff) of my theme 
    $color = dechex(rand(0,222)*65536+rand(0,222)*256+rand(0,222));
    $pattern = '/style=(\'|\")(.*)(\'|\")/i'; 
    $text = preg_replace($pattern, "style=\"color:#{$color};$2;\"", $text); 
    return "<a $text>"; 
}
add_filter('wp_tag_cloud', 'colorCloud', 1);
?>